#ifndef _MListaParadas_h_
#define _MListaParadas_h_

#include <iostream>
#include <fstream>

#include "MAutobuses.h"

using namespace std;
using namespace MAutobuses;

namespace MListaParadas
{ 
    //Es necesario definirlo para el fichero      
    const unsigned int MAXCAD = 30;
    typedef char TCadena[MAXCAD+1];
    
    typedef enum 
    { 
        ErrorNoEncontrado, ErrorParadaExiste, ErrorAperturaFichero, 
        ErrorCrearFichero, ErrorNoHayEspacio, ErrorLineaNoExiste, NoError
    } TError;
    
    struct TParada
    {
        TNatural cod;
        TAutobuses autobuses;   
    };
                      
    typedef struct TNodo *TLista;
    
    struct TNodo
    {
        TParada parada;
        TLista sig;
    };
    
    void CrearLista(TLista &l);
    
    bool ListaVacia(TLista l);
    
	void LeerParadasFichero(TLista &l,TCadena nomFich, TError &err);
    
    void EscribirParadasFichero(TLista l, TCadena nom_fic, TError &err);
    
    void MostrarParadas(TLista l);
    
    void InsertarParada(TLista &l, TNatural parada, TError &err); 
    
    void SubirBajarPasajeros(TLista &l, TNatural parada, TNatural linea, TNatural numSuben, 
                             TNatural &numRealS, TNatural numBajan, TNatural &numRealB, 
                             TError &err);
    
    void BorrarParada(TLista &l,TNatural parada, TError &err);
    
    void DestruirParadas(TLista &l);
    
    void FueraDeServicio(TLista &l, TNatural parada, TError &err);
}

#endif
